package com.jasamedika.medifirst2000.controller;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PapRiwayatTumbuhKembangService;
import com.jasamedika.medifirst2000.vo.PapRiwayatTumbuhKembangVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.HashMap;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

/**
 * Controller class for PapRiwayatTumbuhKembangController
 * 
 * @author Askur
 */
@RestController
@RequestMapping("/riwayat-tumbuh-kembang")
@JsonIgnoreProperties(ignoreUnknown = true)
public class PapRiwayatTumbuhKembangController extends LocaleController<PapRiwayatTumbuhKembangVO> {

	private static final Logger LOGGER = getLogger(PapRiwayatTumbuhKembangController.class);

	@Autowired
	private PapRiwayatTumbuhKembangService<PapRiwayatTumbuhKembangVO> papRiwayatTumbuhKembangService;

	@RequestMapping(value = "/save-riwayat-tumbuh-kembang", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody PapRiwayatTumbuhKembangVO vo,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = papRiwayatTumbuhKembangService.addRiwayatTumbuhKembang(vo);
			if (null != result) {
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
				return getJsonResponse(result, CREATED, mapHeaderMessage);
			} else {
				Map<String, String> headerMessageCustom = new HashMap<>();
				headerMessageCustom.put("label-success", "Pasien belum melakukan pendaftaran");
				return getJsonResponse(null, CREATED, headerMessageCustom);
			}
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when addRiwayatTumbuhKembang", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when addRiwayatTumbuhKembang", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

}
